unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Menus, StdCtrls, ExtCtrls, Buttons, inifiles, ScktComp, shellapi,
  unit2, unitx, AppEvnts;


const rcvsize=10000;
      WM_ICON = wm_user + 10;

type
     rcvbuf = array [0..rcvsize] of char;
     tshowdata=(shhex,shbinary,shascii);
     ticonstate = (isyellow,isred,isgreen);
     thowiconstate = (isadd,isdelete,ismodify);

  TDCFTime = record
   rtime: TDateTime;
   r,a1,z1,z2,a2,s,ho,mi,se,ms,d,m,y,dw: integer;
   vt: boolean;
  end;

  TReadThread = class(TThread)
  public
   fs: string;
   constructor Create;
   procedure Execute; override;
   procedure ShowStr;
  end;


  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Program1: TMenuItem;
    About1: TMenuItem;
    Exit1: TMenuItem;
    sb1: TStatusBar;
    device1: TMenuItem;
    m: TMemo;
    Open1: TMenuItem;
    Close1: TMenuItem;
    Info1: TMenuItem;
    N2: TMenuItem;
    GetTime1: TMenuItem;
    DCFStart1: TMenuItem;
    Timer1: TTimer;
    GetTimeTimerOnOff1: TMenuItem;
    ON3: TMenuItem;
    OFF3: TMenuItem;
    GetDecodedTime1: TMenuItem;
    NTP1: TMenuItem;
    Server1: TMenuItem;
    ON1: TMenuItem;
    OFF1: TMenuItem;
    cliquery1: TMenuItem;
    GetDecodedTime2: TMenuItem;
    GetTime2: TMenuItem;
    PopupMenu1: TPopupMenu;
    Showwindow1: TMenuItem;
    ApplicationEvents1: TApplicationEvents;
    N3: TMenuItem;
    Exit2: TMenuItem;
    LastClientQuery1: TMenuItem;
    procedure About1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Info1Click(Sender: TObject);
    procedure GetTime1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure GetTimeTimerOnOff1Click(Sender: TObject);
    procedure ON3Click(Sender: TObject);
    procedure OFF3Click(Sender: TObject);
    procedure GetDecodedTime1Click(Sender: TObject);
    procedure NTPON1Click(Sender: TObject);
    procedure NTPOFF1Click(Sender: TObject);
    procedure cliquery1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure GetDecodedTime2Click(Sender: TObject);
    procedure GetTime2Click(Sender: TObject);
    procedure Showwindow1Click(Sender: TObject);
    procedure ApplicationEvents1Minimize(Sender: TObject);
    procedure Exit2Click(Sender: TObject);
    procedure LastClientQuery1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
   procedure WMIcon(var Message: TMessage); message WM_ICON;
   procedure AddStr(s:string);
   function openport: boolean;
   function doopenport(var ph: thandle): boolean;
   procedure SendCmd(cmd: string; chars: byte);
   procedure DecodeData(rcv: rcvbuf);
   procedure GetDecodedTime(rl: byte);
   procedure UpdateStatus;
   procedure UpdateSystemTime(d: TDCFTime);
   procedure SetIcon(how: thowiconstate; state: ticonstate; tit: string);
  end;

var

  Form1: TForm1;
  LastUpdatedLocalTime: TDateTime = 0;

const

  CliSetNTPTime: boolean = false;

implementation

{$R *.DFM}
{$R *.RES}

const
  crlf= #13#10;
  initsection='init';
  showsend: boolean = false;
  showdata: tshowdata = shhex;
  showcrlf: boolean = false;
  showlog: boolean = true;
  autoopen: boolean = true;
  autostartntp: boolean = false;
  loglines: integer = 100;
  trayicon: boolean = false;
  writelog: boolean = true;
  WriteData: boolean = false;
  DCFSetTime: boolean = false;
  TimerEnable: boolean = true;
  TimerGetDecodedTime: boolean = true;
  dcftimer: integer = 1; // one minute
  century: integer = 2000;
  SynchronizeDiff: dword = 0;
  SynchronizeMaxDiff: integer = 23;
  ValidDateTimeCount: integer = 3;
  weekday: array [0..7] of string =
  ('Unknown','Monday','Tuesday','Wednesday','Thursday','Friday','Saturday','Sunday');

  cmdlength = 2;
  infocmd = #1;
  get_time_sync = #3#1;
  get_time_nosync = #3#0;
  get_time_rcvlen = 27;
  decode_time_sync = #4#1;
  decode_time_nosync = #4#0;
  decode_time_rcvlen = 11;
  dcf_start_stop_ON = #5#1;
  dcf_start_stop_OFF = #5#0;
  debug_dcf_data_ON = #6#1;
  debug_dcf_data_OFF = #6#0;
  get_time1 = #7;

var
  rcvtimeout: integer = 2;
  readthread: treadthread = nil;
  comhandle: thandle= 0;
  nrcv: cardinal;
  rcv: rcvbuf;
  portopen: boolean = false;
  inifilepth: string;
  ValidDateTime: integer = 0;
  LastDateTime: TSystemTime;
  taskbar: THandle = 0;

function GetErrStr(r: integer; s: string): string;
begin
 result := s + format(' error %d - %s',[r,syserrormessage(r)]);
end;


constructor TReadThread.Create;
begin
 inherited Create(true);
 freeonterminate := true;
 priority := tpNormal;
 resume;
end;

procedure TReadthread.ShowStr;
begin
 if (Form1 <> nil) and (fs <> '') then Form1.addstr('R: '+ fs);
end;

procedure TReadthread.Execute;
var i: integer;
    r: array [0..rcvsize] of char;
    nr,cst:cardinal;
    st: tcomstat;
begin
 fillchar(rcv,sizeof(rcv), 0); nrcv := 0;
 repeat
try
  if ClearCommError(comhandle,cst,@st) then begin
    sleepex(10,true);
    if st.cbInQue > 0 then begin
      if readfile(comhandle, r, sizeof(r)-1, nr, nil) then begin

       if nrcv + nr > rcvsize then begin
        fs := 'Buffer full'; Synchronize(ShowStr);
        nrcv := 0;
        if nr > rcvsize then continue; // discard chars
       end;

        move(r[0],rcv[nrcv],nr); nrcv := nrcv + nr;  fs := '';
        if nr <> 0 then begin
         for i := 0 to nr-1 do begin
          case showdata of
           shhex: begin
            if showcrlf and (r[i] = #13) then fs := fs + '<CR>' else
            if showcrlf and (r[i] = #10) then fs := fs + '<LF>' else
            fs := fs + inttohex(byte(r[i]),2);
           end;
           shbinary: begin
            if showcrlf and (r[i] = #13) then fs := fs + '<CR>' else
            if showcrlf and (r[i] = #10) then fs := fs + '<LF>' else
            fs := fs + binb(byte(r[i]));
           end;
           shascii: begin
            if r[i] = #13 then fs := fs + '<CR>' else
            if r[i] = #10 then fs := fs + '<LF>' else
            if r[i] in [#32..#126] then fs := fs + r[i] else
              fs := fs + '0x'+inttohex(byte(r[i]),2);
           end;
          end;
          if showdata <> shascii then fs := fs + ' ';
         end;
          Synchronize(ShowStr);
        end;
      end;
    end;
  end;
except
 on e: exception do ebox('Thread '+e.message);
end;
 until application.Terminated or terminated;
end;


function waitrcv(chars: byte): boolean;
var t: tdatetime;
    timeout: boolean;
begin
 t := now + 2/(24*3600);
 repeat
  sleepex(100,true);
  timeout := t < now;
  application.ProcessMessages;
 until (nrcv >= chars) or timeout;
 if timeout then result := false else result := true;
end;


procedure TForm1.UpdateSystemTime(d: TDCFTime);
var systime: TSystemTime;
    t,t1: TDateTime;
    s,sign: string;
begin
try
 // if received time is "Sync" width DCF device:
 // add min 6ms for "Get Decoded Time"
 // add min 15ms for "Get Time Data"
 // add processor time ???ms or optimize program code :-)

 AddStr(format('R:%d A1:%d Z1:%d Z2:%d A2:%d S:%d',[d.r,d.a1,d.z1,d.z2,d.a2,d.s]));
 AddStr(format('%.2d:%.2d:%.2d.%.3d %d.%d.%d %s',[d.ho,d.mi,d.se,d.ms,d.d,d.m,d.y,weekday[d.dw]]));

 if not d.vt then begin
  SetIcon(ismodify,isred,'Bad parity...');
  ValidDateTime := 0; exit;
 end;

 if d.ms >= 1000 then d.ms := 0; // correct bad data
 if d.dw = 7 then d.dw := 0;
 if (LastDateTime.wYear <> d.y) or
    (LastDateTime.wMonth <> d.m) or
    (LastDateTime.wDayOfWeek <> d.dw) or
    (LastDateTime.wDay <> d.d) or
    (LastDateTime.wHour <> d.ho) or
    (LastDateTime.wMinute <> d.mi) then begin  // only next minute
//    (LastDateTime.wSecond <> d.se) or
//    (LastDateTime.wMilliseconds <> d.ms) then begin
  LastDateTime.wYear := d.y;
  LastDateTime.wMonth := d.m;
  LastDateTime.wDayOfWeek := d.dw;
  LastDateTime.wDay := d.d;
  LastDateTime.wHour := d.ho;
  LastDateTime.wMinute := d.mi;
  LastDateTime.wSecond := d.se;
  LastDateTime.wMilliseconds := d.ms;
  inc(ValidDateTime);
 end;
 t := d.rtime - (EncodeDate(d.y,d.m,d.d) + EncodeTime(d.ho,d.mi,d.se,d.ms));
 if t < 0 then sign := '-' else sign := '';
 t1 := abs(t);
 s := 'Time diff: '+sign+inttostr(Trunc(t1))+'d '+formatdatetime('hh:nn:ss.zzz',t1)+
        ' ContValidTime: ' + inttostr(ValidDateTime);
 AddStr(s);
 if not DCFSetTime then begin
  SetIcon(ismodify,isyellow,s);
  exit;
 end;
 if ValidDateTime >= ValidDateTimeCount then begin
  SetIcon(ismodify,isgreen,s);
  if SynchronizeDiff <= (t1 * 24*3600*1000) then begin //ms
   if SynchronizeMaxDiff < (t1*24) then begin // hours
    AddStr('Big difference, can''t synchronize time...');
   end else begin
    AddStr('Synchronizing time...');
    t1 := Now - t;
//    AddStr('Synchronizing time to '+formatdatetime('dd.mm.yyyy hh:nn:ss.zzz',t1));    
    DateTimeToSystemTime(t1, systime);
    if not SetLocalTime(systime) then begin
     AddStr(GetErrStr(GetLastError,'SetLocalTime'));
     SetIcon(ismodify,isred,s);
    end else begin
     LastUpdatedLocalTime := d.rtime;
    end;
   end;
  end else begin
   LastUpdatedLocalTime := d.rtime;
  end;
 end;
except
 on e: exception do AddStr('UpdateSystemTime error: '+e.message);
end;
end;

function ChangeBarIcon(how: thowiconstate; wh: THandle; msg: integer;
                    icon: hicon; tit: string): boolean;
var TaskIcon: NOTIFYICONDATA;
begin
 result := false;
 if not trayicon then exit;
 fillchar(TaskIcon, sizeof(TaskIcon), 0);
 with TaskIcon do
  begin
   cbSize := sizeof(TaskIcon);
   Wnd := wh;
   uID := 123456789;
   uflags := NIF_ICON + NIF_MESSAGE + NIF_TIP;
   uCallbackMessage := msg;
   hIcon := icon;
   strpcopy(szTip, tit);
  end;
  case how of
   isadd: result := Shell_NotifyIcon(NIM_ADD, @TaskIcon);
   isdelete: result := Shell_NotifyIcon(NIM_DELETE, @TaskIcon);
   else result := Shell_NotifyIcon(NIM_MODIFY, @TaskIcon);
  end;
end;

procedure ShowTaskBar(how: boolean; atitle: string);
var a: array [0..255] of char;
begin
 if not trayicon then exit;
 if taskbar = 0 then taskbar := findwindow('TApplication', strpcopy(a, atitle));
 if taskbar <> 0 then begin
  if how then showwindow(taskbar,sw_show) else showwindow(taskbar,sw_hide);
 end;
end;

procedure TForm1.SetIcon(how: thowiconstate; state: ticonstate; tit: string);
var ic: hicon;
const ics=16;
begin
 if not trayicon then exit;
 if tit <> '' then tit := caption + ' - ' + tit else tit := caption; 
 case state of
  isgreen : ic := LoadImage(hinstance, 'CLOCKGR',IMAGE_ICON,ics,ics,LR_DEFAULTCOLOR);
  isred   : ic := LoadImage(hinstance, 'CLOCKRE',IMAGE_ICON,ics,ics,LR_DEFAULTCOLOR);
 else ic := LoadImage(hinstance, 'CLOCKYE',IMAGE_ICON,ics,ics,LR_DEFAULTCOLOR);
 end;
 if ic <> 0 then ChangeBarIcon(how,handle,wm_icon,ic, tit);
end;

procedure TForm1.WMIcon(var Message: TMessage);
begin
 case Message.lparam of
  WM_LBUTTONDBLCLK: begin
   Showwindow1Click(self);
  end;
  WM_RBUTTONDOWN: begin
   SetForegroundWindow(Handle);
   popupmenu1.Popup(mouse.cursorpos.x,mouse.cursorpos.y);
   PostMessage(Handle, WM_NULL, 0, 0);
  end;
 end;
end;

procedure TForm1.Showwindow1Click(Sender: TObject);
begin
 application.restore;
 SetForegroundWindow(Handle);
end;

function TForm1.doopenport(var ph: thandle): boolean;
var dcb: tdcb;
    t:COMMTIMEOUTS;
    f: TIniFile;
    c: string;
    brate: integer;
begin
 result := false;
 f := tinifile.create(inifilepth);
try
 c := uppercase(f.ReadString(initsection,'port','\\.\COM1'));
 brate := f.ReadInteger(initsection,'baud',19200);
finally
 f.free;
end;
 ph := CreateFile(pchar(c),
    GENERIC_READ or GENERIC_WRITE, 0,nil, OPEN_EXISTING, 0, 0);

 if ph = INVALID_HANDLE_VALUE then begin
  ebox('CreateFile INVALID_HANDLE_VALUE'#13+SysErrMsg);
  exit;
 end;

 dcb.DCBlength := sizeof(dcb);
 if not GetCommState(ph, dcb) then
  begin
   ebox('ComHandle GetCommState '#13+SysErrMsg);
   exit;
  end;

 dcb.BaudRate := brate;
 dcb.Parity := 0;
 dcb.ByteSize := 8;
 dcb.StopBits := ONESTOPBIT;

 if not SetCommState(ph, dcb) then
  begin
   ebox('ComHandle SetCommState '#13+SysErrMsg);
   exit;
  end;

 EscapeCommFunction(ph, SETDTR);
 EscapeCommFunction(ph, SETRTS);

 if not  getcommtimeouts(ph,t) then
  begin
   ebox('ComHandle GetCommTimeOuts '#13+SysErrMsg);
   exit;
  end;

 t.ReadIntervalTimeout := 100;
 t.ReadTotalTimeoutMultiplier := 1;

 if not setcommtimeouts(ph, t) then
  begin
   ebox('ComHandle SetCommTimeOuts '#13+SysErrMsg);
   exit;
  end;
 result := true;
end;

procedure ClearCom(h: thandle);
var r: array [0..1000] of char;
    nr,cst:cardinal;
    st: tcomstat;
begin
 if ClearCommError(comhandle,cst,@st) and (st.cbInQue > 0) then begin
  readfile(h, r, sizeof(r)-1, nr, nil);
 end;
end;

function TForm1.OpenPort: boolean;
begin

 if readthread <> nil then
  begin
   readthread.Terminate;
   terminatethread(readthread.handle, 0);
   SetCommMask(comhandle, 0);
   wdelay(500);
  end;

 if comhandle <> 0 then if closehandle(comhandle) then comhandle := 0;
 result := false;

 if not DoOpenPort(comhandle) then exit;

 if not SetCommMask(comhandle, EV_RXCHAR) then begin
  ebox('ComHandle SetCommMask '#13+SysErrMsg);
 end;

 sleep(100);
 ClearCom(comhandle);
 readthread := Treadthread.Create;

 result := true;
 portopen := true;
 addstr('COM port opened');
end;

function SendString(s: string): boolean;
var wb: cardinal;
    l: integer;
begin
 result := false;
 fillchar(rcv,sizeof(rcv), 0); nrcv := 0;
 l := length(s);
 if not writefile(comhandle, s[1], l, wb, nil) then begin
  EBox(SysErrMsg);
 end else result := true;
end;

procedure TForm1.AddStr(s:string);
begin
 s := formatdatetime('dd.mm.yyyy hh:nn:ss.zzz ',now)+s;
 m.lines.BeginUpdate;
try
 if loglines > 0 then begin
  while m.lines.count > loglines do begin
   m.Lines.Delete(m.lines.count-1);
  end;
 end;
 m.lines.insert(0,s);
 if writelog then xwritetostringfile(s+crlf,_exedir+_exename+'.log');
finally
 m.lines.EndUpdate;
end;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
 Ibox('DCF77 service v1.0'#13#13'(c) Zelenka 2012');
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
 close;
end;

procedure TForm1.Exit2Click(Sender: TObject);
begin
 if qbox('Are you sure?') = idyes then begin
  Showwindow1Click(Sender);
  Exit1Click(Sender);
 end;
end;


const issending: boolean = false;
procedure TForm1.SendCmd(cmd: string; chars: byte);
var s,p: string;
    i: integer;
begin
 if issending then begin
  beep;
  showlog := true;
  addstr('Cmd in progress...');
  exit;
 end;
 issending := true;
try
 sb1.Panels[1].text := '';
 if not portopen then OpenPort;
 for i := length(cmd)+1 to cmdlength do cmd := cmd + #0;
 sb1.Panels[1].text := 'Sending data...';
 p := '';
 for i := 1 to length(cmd) do p := p + '0x'+inttohex(byte(cmd[i]),2)+' ';
 if showsend then addstr('S: '+p)
  else addstr('S: '+inttostr(length(cmd))+'B');
 if sendstring(cmd) then begin
  if waitrcv(chars) then begin
  s := copy(rcv,1,nrcv-2);
  end else begin
   addstr('Receive error!');
   beep;
  end;
 end;
 sb1.Panels[1].Text := p;
finally
 issending := false;
end;
end;

procedure UpdateIniFile(ident: string; value: boolean);
var f: tinifile;
begin
 f := tinifile.create(inifilepth);
try
 f.WriteBool(initsection,ident,value);
finally
 f.free;
end;
end;


procedure TForm1.FormCreate(Sender: TObject);
var f: tinifile;
begin
 decimalseparator := '.';
 m.Clear;
 inifilepth := _exedir+_exeini;
 f := tinifile.create(inifilepth);
try
 autoopen := f.ReadBool(initsection,'AutoOpen',autoopen);
 autostartntp := f.ReadBool(initsection,'AutoStartNtp',autostartntp);
 NTP_Server := f.ReadString(initsection,'NtpServer',NTP_Server);
 loglines := f.ReadInteger(initsection,'LogLines',loglines);
 trayicon := f.ReadBool(initsection,'TrayIcon',trayicon);
 writelog := f.ReadBool(initsection,'WriteLog',writelog);
 WriteData := f.ReadBool(initsection,'WriteData',writedata);
 DCFSetTime :=  f.ReadBool(initsection,'DCFSetTime',DCFSetTime);
 CliSetNTPTime :=  f.ReadBool(initsection,'CliSetNTPTime',CliSetNTPTime);
 century := f.ReadInteger(initsection,'Century',century);
 SynchronizeDiff := f.ReadInteger(initsection,'SynchronizeDiff',SynchronizeDiff);
 SynchronizeMaxDiff := f.ReadInteger(initsection,'SynchronizeMaxDiff',SynchronizeMaxDiff);
 ValidDateTimeCount := f.ReadInteger(initsection,'ValidDateTimeCount',ValidDateTimeCount);
 TimerEnable := f.ReadBool(initsection,'TimerEnable',TimerEnable);
 TimerGetDecodedTime := f.ReadBool(initsection,'TimerGetDecodedTime',TimerGetDecodedTime);
 GetDecodedTime1.Checked := TimerGetDecodedTime;
 GetTime1.Checked := not TimerGetDecodedTime;
 GetTimeTimerOnOff1.Checked := TimerEnable;
 dcftimer := f.ReadInteger(initsection,'Timer',dcftimer);
 if dcftimer < 1 then dcftimer := 1;
 timer1.Interval := dcftimer * 60000;
 timer1.Enabled := TimerEnable;
finally
 f.free;
end;
 UpdateStatus;
 SetIcon(isadd,isyellow,'');
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 EscapeCommFunction(comhandle, CLRRTS);
 EscapeCommFunction(comhandle, CLRDTR);
 if comhandle <> 0 then closehandle(comhandle);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 NTPOFF1Click(Sender);
 SetIcon(isdelete,isyellow,'');
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
 openport;
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
 if readthread <> nil then
  begin
   readthread.Terminate;
   terminatethread(readthread.handle, 0);
   SetCommMask(comhandle, 0);
   wdelay(500);
  end;
 if comhandle <> 0 then
 if closehandle(comhandle) then begin
  portopen := false;
  comhandle := 0;
 end;
 addstr('COM port closed');
end;

const first:boolean = true;
procedure TForm1.FormActivate(Sender: TObject);
begin
 if first then begin
  first := false;
  if autoopen then openport;
  if autostartntp then NTPON1Click(Sender);
 end;
end;

procedure TForm1.Info1Click(Sender: TObject);
begin
 showdata := shascii;
 SendCmd(infocmd,2);
 showdata := shhex;
end;

function rbin(v: byte): string;
var i,j,k,l: byte;
begin
 j := 0;
 for i := 0 to 7 do begin
  k := 7-i;
  l := (1 shl i);
  if (v and l) > 0 then  j := j + (1 shl k);
 end;
 result := binb(j);
end;

function GetValue(c: cardinal): byte;
var i: integer;
    r,k,l: byte;
    s: string;
begin
 r := 0;
 for i := 0 to 7 do begin
  k := 1 shl i;
  s := inttohex(k,1);
  l := strtoint(s);
  if (c and k) = k then r := r + l;
 end;
 result := r;
end;

function GetParity(c: cardinal;l,p: byte): boolean;
var i,n: integer;
    k: cardinal;
begin
 n := 0;
 for i := 0 to l -1 do begin
  k := (1 shl i);
  if c and k = k then inc(n);
 end;
 result := p = (n mod 2);
end;

procedure TForm1.DecodeData(rcv: rcvbuf);
var t: array [0..11] of byte;
    d: TDCFTime;
    i,p1,p2,p3: integer;
    p: string;
    dt: cardinal;
const recvchr: char = #$3B;
begin
  d.rtime := Now; d.vt := true;
  for i := 12 to 23 do p := p + ' ' +inttohex(byte(rcv[i]),2);
  p := formatdatetime('dd.mm.yyyy hh:nn:ss ',now)+p;
  for i := 15 to 23 do p := p + ' '+rbin(byte(rcv[i])); //binb(byte(rcv[n]));
  if (rcv[12] = #0) and (rcv[13] = recvchr) and WriteData then
   xwritetostringfile(p+crlf,_exedir+_exename+'.dat');

  move(rcv[12],t,sizeof(t));
  d.r := byte((t[4] and 128) <> 0);
  d.a1 := byte((t[5] and 1) <> 0);
  d.z1 := byte((t[5] and 2) <> 0);
  d.z2 := byte((t[5] and 4) <> 0);
  d.a2 := byte((t[5] and 8) <> 0);
  d.s := byte((t[5] and 16) <> 0);
  if (rcv[12] <> #0) or (rcv[13] <> recvchr) then begin
   addstr('Bad data!'); ValidDateTime := 0; SetIcon(ismodify,isred,'Bad data!');
  end else begin
   if d.s = 0 then begin
    addstr('Bad start bit!'); d.vt := false;
   end;
   if byte(rcv[0]) <> 0 then begin
    addstr('Bad marks in new minute!'); d.vt := false;
   end;

   d.se := byte(rcv[1]);
   move(t[5],dt,sizeof(dt));
   dt := dt shr 5;
   d.mi := GetValue(dt and 127);
   p1 := (dt shr 7) and 1;
   if not GetParity(dt and 127,7,p1) then begin
    addstr('Bad minute parity!'); d.vt := false;
   end;
   dt := dt shr 8;
   d.ho := GetValue(dt and 63);
   p2 := (dt shr 6) and 1;
   if not GetParity(dt and 63,6,p2) then begin
    addstr('Bad hour parity!'); d.vt := false;
   end;

   dt := dt shr 7;
   d.d := GetValue(dt and 63);
   move(t[8],dt,sizeof(dt));
   dt := dt shr 2;
   d.dw := dt and 7;
   dt := dt shr 3;
   d.m := GetValue(dt and 31);
   dt := dt shr 5;
   d.y := century + GetValue(dt and 255);
   d.ms := byte(rcv[24])*10;

   move(t[7],dt,sizeof(dt));
   p3 := (dt shr 26) and 1;
   dt := (dt shr 4) and $3FFFFF;
   if not GetParity(dt,22,p3) then begin
    addstr('Bad date parity!'); d.vt := false;
   end;

   UpdateSystemTime(d);
  end;
end;


procedure TForm1.GetTime1Click(Sender: TObject);
begin
 SendCmd(get_time_sync,get_time_rcvlen);
 if nrcv >= get_time_rcvlen then begin
  DecodeData(rcv);
 end;
end;

procedure TForm1.GetTime2Click(Sender: TObject);
begin
 SendCmd(get_time_nosync,get_time_rcvlen);
 if nrcv >= get_time_rcvlen then begin
  DecodeData(rcv);
 end;
end;

procedure TForm1.GetTimeTimerOnOff1Click(Sender: TObject);
begin
 if GetTimeTimerOnOff1.Checked then begin
   GetTimeTimerOnOff1.Checked := false;
 end else begin
   GetTimeTimerOnOff1.Checked := true;
 end;
 timer1.Enabled := GetTimeTimerOnOff1.Checked;
 UpdateIniFile('TimerEnable',timer1.enabled);
 UpdateStatus;
end;

procedure TForm1.GetDecodedTime(rl: byte);
var b,f: word;
    d: TDCFTime;
const fminp = 16;
      fhourp = 32;
      fdatep = 64;
      fdatac = 128;
begin
 d.rtime := Now; d.vt := true; d.s := 1;
 if nrcv >= rl then begin
  f := byte(rcv[0]);
  d.a1 := byte((f and 1) <> 0);
  d.z1 := byte((f and 2) <> 0);
  d.z2 := byte((f and 4) <> 0);
  d.a2 := byte((f and 8) <> 0);
  d.mi := byte(rcv[1]);
  d.ho := byte(rcv[2]);
  d.d := byte(rcv[3]);
  d.m := byte(rcv[4]) and $0F;
  d.dw := (byte(rcv[4]) and $70) shr 4;
  d.r := (byte(rcv[4]) and $80) shr 7;
  d.y := century + byte(rcv[5]);
  d.se := byte(rcv[6]);
  b := byte(rcv[7]);
  d.ms := byte(rcv[8]) * 10;
  if f and fdatac = 0 then begin
   addstr('Bad data!'); ValidDateTime := 0; SetIcon(ismodify,isred,'Bad data!');
  end else begin
   if f and fminp = fminp then begin
    addstr('Bad minute parity!'); d.vt := false;
   end;
   if f and fhourp = fhourp then begin
    addstr('Bad hour parity!'); d.vt := false;
   end;
   if f and fdatep = fdatep then begin
    addstr('Bad date parity!'); d.vt := false;
   end;
   if b <> 0 then begin
    addstr('Bad marks in new minute!'); d.vt := false;
   end;
   UpdateSystemTime(d);
  end;
 end;
end;

procedure TForm1.GetDecodedTime1Click(Sender: TObject);
begin
 SendCmd(decode_time_sync,decode_time_rcvlen);
 GetDecodedTime(decode_time_rcvlen);
end;

procedure TForm1.GetDecodedTime2Click(Sender: TObject);
begin
 SendCmd(decode_time_nosync,decode_time_rcvlen);
 GetDecodedTime(decode_time_rcvlen);
end;

procedure TForm1.ON3Click(Sender: TObject);
begin
 SendCmd(dcf_start_stop_ON,2);
end;

procedure TForm1.OFF3Click(Sender: TObject);
begin
 SendCmd(dcf_start_stop_OFF,2);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
 if TimerGetDecodedTime then
  GetDecodedTime1Click(Sender) else GetTime1Click(Sender);
end;

procedure TForm1.UpdateStatus;
var s: string;
begin
 s := '';
 if GetTimeTimerOnOff1.Checked then s := 'Timer ON -' else s := 'Timer OFF -';
 if NTPSrvOnOff then s := s + ' NTPSrv ON' else s := s + ' NTPSrv OFF';
 sb1.Panels[0].text := s;
end;

procedure TForm1.ApplicationEvents1Minimize(Sender: TObject);
begin
 ShowTaskBar(false, application.title);
end;



procedure TForm1.NTPON1Click(Sender: TObject);
begin
 StartNTPServer;
 UpdateStatus;
end;

procedure TForm1.NTPOFF1Click(Sender: TObject);
begin
 StopNTPServer;
 UpdateStatus;
end;

procedure TForm1.cliquery1Click(Sender: TObject);
begin
 if InputQuery('NTP server IP','', NTP_Server) then begin
  addstr('Cli Quering '+NTP_Server+'...');
  NTPClientQuery(NTP_Server);
 end;
end;

procedure TForm1.LastClientQuery1Click(Sender: TObject);
begin
 if trim(NTP_Server) <> '' then NTPClientQuery(NTP_Server)
 else cliquery1Click(Sender);
end;








end.


